SageMath 9.8 beta 4: Error building a wheel for scipy-1.9.2

73 views
Skip to first unread message

being nobody00

unread,
Nov 26, 2022, 3:40:30 PM11/26/22
to sage-devel
Dear SageMath,

scipy-1.92 was successfully built with the default configuration:

./configure

SageMath was then built again with:

,/configure --prefix=/mnt/g/Maths/sage-9.8/b4.0

This new build failed at 'scipy-1.9.2'.  Your help to debug and fix this issue is much appreciated. 
Please find 'non-default-config.log', 'non-default-scipy-1.9.2.log' and 'default-scipy-1.9.2.log' in the attached 'report.b4.0.7z'

With best wishes and regards,

phi




report.b4.0.7z

John H Palmieri

unread,
Nov 27, 2022, 12:32:43 AM11/27/22
to sage-devel
What OS? I'm guessing Mac OS, in which case you need the fix at https://trac.sagemath.org/ticket/34658, or build 9.8.beta3 or wait for a later beta release that includes the fix.

--
John

being nobody00

unread,
Nov 27, 2022, 3:10:28 AM11/27/22
to sage-devel
> What OS?
$ uname -a
Linux PC1 4.4.0-17763-Microsoft #2268-Microsoft Thu Oct 07 16:36:00 PST 2021 x86_64 x86_64 x86_64 GNU/Linux

Please find appended below excerpts from 'config.log' and 'scipy-1.9.2.log'.
Maybe this is newly introduced after https://trac.sagemath.org/ticket/34658?

FWIW, beta 4 was successfully built with the default prefix (aka root?):

./configure

It is hoped that 'non-default-config.log', 'non-default-scipy-1.9.2.log' and 'default-scipy-1.9.2.log'  in the 'report.b4.0.7z'  (attached  in the original post) were investigated.

'non-default' here means:

 $ ./configure --prefix=/mnt/g/Maths/sage-9.8/b4.0

Please advise if there are any other data is needed for the investigation.

Best regards,

phi

<config.log>
...
...
  $ ./configure --prefix=/mnt/g/Maths/sage-9.8/b4.0

## --------- ##
## Platform. ##
## --------- ##

hostname = PC1
uname -m = x86_64
uname -r = 4.4.0-17763-Microsoft
uname -s = Linux
uname -v = #2268-Microsoft Thu Oct 07 16:36:00 PST 2021

/usr/bin/uname -p = x86_64
/bin/uname -X     = unknown

/bin/arch              = x86_64
/usr/bin/arch -k       = unknown
/usr/convex/getsysinfo = unknown
/usr/bin/hostinfo      = unknown
/bin/machine           = unknown
/usr/bin/oslevel       = unknown
/bin/universe          = unknown
...
...

</config.log>
...
...

<scipy-1.9.2.log>
  SciPy 1.9.2

    User defined options
      Native files: /mnt/g/Maths/sage-9.8/b4.0/var/tmp/sage/build/scipy-1.9.2/src/.mesonpy-native-file.ini
      debug       : false
      optimization: 2
      prefix      : /mnt/g/Maths/sage-9.8/b4.0

  Found ninja-1.10.0 at /usr/bin/ninja
  WARNING: custom_target '_cython_tree' has more than one output! Using the first one.
...
...
  WARNING: custom_target '_cython_tree' has more than one output! Using the first one.
  [1/1576] Generating scipy/generate-version with a custom command
  [2/1576] Generating scipy/_cython_tree with a custom command
  [3/1576] Generating scipy/_lib/_lib_pxd with a custom command
  [4/1576] Compiling C++ object scipy/_lib/_uarray/_uarray.cpython-310-x86_64-linux-gnu.so.p/_uarray_dispatch.cxx.o
  FAILED: scipy/_lib/_uarray/_uarray.cpython-310-x86_64-linux-gnu.so.p/_uarray_dispatch.cxx.o
  g++ -Iscipy/_lib/_uarray/_uarray.cpython-310-x86_64-linux-gnu.so.p -Iscipy/_lib/_uarray -I../../scipy/_lib/_uarray -I/mnt/g/Maths/sage-9.8/b4.0/include/python3.10 -fvisibility=hidden -fvisibility-inlines-hidden -fdiagnostics-color=always -D_FILE_OFFSET_BITS=64 -Wall -Winvalid-pch -Wnon-virtual-dtor -std=c++14 -O2 -g -O2 -fPIC -Wno-terminate -Wno-unused-function -MD -MQ scipy/_lib/_uarray/_uarray.cpython-310-x86_64-linux-gnu.so.p/_uarray_dispatch.cxx.o -MF scipy/_lib/_uarray/_uarray.cpython-310-x86_64-linux-gnu.so.p/_uarray_dispatch.cxx.o.d -o scipy/_lib/_uarray/_uarray.cpython-310-x86_64-linux-gnu.so.p/_uarray_dispatch.cxx.o -c ../../scipy/_lib/_uarray/_uarray_dispatch.cxx
  In file included from /usr/include/features.h:461,
                   from /usr/include/x86_64-linux-gnu/c++/9/bits/os_defines.h:39,
                   from /usr/include/x86_64-linux-gnu/c++/9/bits/c++config.h:528,
                   from /usr/include/c++/9/cassert:43,
                   from ../../scipy/_lib/_uarray/small_dynamic_array.h:2,
                   from ../../scipy/_lib/_uarray/_uarray_dispatch.cxx:1:
  /usr/include/x86_64-linux-gnu/sys/cdefs.h:453:10: fatal error: scipy/_lib/_uarray/_uarray.cpython-310-x86_64-linux-gnu.so.p/bits/long-double.h: Invalid argument
    453 | #include <bits/long-double.h>
        |          ^~~~~~~~~~~~~~~~~~~~
  compilation terminated.
  [5/1576] Generating scipy/generate-config with a custom command
  [6/1576] Generating 'scipy/_lib/_test_deprecation_call.cpython-310-x86_64-linux-gnu.so.p/_test_deprecation_call.c'.
  FAILED: scipy/_lib/_test_deprecation_call.cpython-310-x86_64-linux-gnu.so.p/_test_deprecation_call.c
  /mnt/g/Maths/sage-9.8/b4.0/var/tmp/sage/build/scipy-1.9.2/src/scipy/_build_utils/cythoner.py ../../scipy/_lib/_test_deprecation_call.pyx scipy/_lib/_test_deprecation_call.cpython-310-x86_64-linux-gnu.so.p/_test_deprecation_call.c
  /bin/sh: 1: /mnt/g/Maths/sage-9.8/b4.0/var/tmp/sage/build/scipy-1.9.2/src/scipy/_build_utils/cythoner.py: not found
  [7/1576] Generating 'scipy/_lib/_ccallback_c.cpython-310-x86_64-linux-gnu.so.p/_ccallback_c.c'.
  FAILED: scipy/_lib/_ccallback_c.cpython-310-x86_64-linux-gnu.so.p/_ccallback_c.c
  /mnt/g/Maths/sage-9.8/b4.0/var/tmp/sage/build/scipy-1.9.2/src/scipy/_build_utils/cythoner.py ../../scipy/_lib/_ccallback_c.pyx scipy/_lib/_ccallback_c.cpython-310-x86_64-linux-gnu.so.p/_ccallback_c.c
  /bin/sh: 1: /mnt/g/Maths/sage-9.8/b4.0/var/tmp/sage/build/scipy-1.9.2/src/scipy/_build_utils/cythoner.py: not found
  [8/1576] Compiling C object scipy/_lib/_fpumode.cpython-310-x86_64-linux-gnu.so.p/_fpumode.c.o
  [9/1576] Compiling C object scipy/special/libcephes.a.p/cephes_bdtr.c.o
  FAILED: scipy/special/libcephes.a.p/cephes_bdtr.c.o
  gcc -Iscipy/special/libcephes.a.p -Iscipy/special -I../../scipy/special -I/mnt/g/Maths/sage-9.8/b4.0/lib/python3.10/site-packages/numpy/core/include -Iscipy/_lib -I../../scipy/_lib -I../../scipy/_build_utils/src -I/mnt/g/Maths/sage-9.8/b4.0/include/python3.10 -fdiagnostics-color=always -D_FILE_OFFSET_BITS=64 -Wall -Winvalid-pch -std=c99 -O2 -Wno-unused-but-set-variable -Wno-unused-function -Wno-conversion -Wno-misleading-indentation -Wno-incompatible-pointer-types -Wno-unused-but-set-variable -g -O2 -fPIC -MD -MQ scipy/special/libcephes.a.p/cephes_bdtr.c.o -MF scipy/special/libcephes.a.p/cephes_bdtr.c.o.d -o scipy/special/libcephes.a.p/cephes_bdtr.c.o -c ../../scipy/special/cephes/bdtr.c
  In file included from /mnt/g/Maths/sage-9.8/b4.0/include/python3.10/Python.h:30,
                   from ../../scipy/special/cephes/mconf.h:56,
                   from ../../scipy/special/cephes/bdtr.c:149:
  /usr/include/string.h:153:11: fatal error: scipy/special/libcephes.a.p/bits/types/locale_t.h: Invalid argument
    153 | # include <bits/types/locale_t.h>
        |           ^~~~~~~~~~~~~~~~~~~~~~~
  compilation terminated.
  [10/1576] Compiling C object scipy/_lib/_test_ccallback.cpython-310-x86_64-linux-gnu.so.p/src__test_ccallback.c.o
  [11/1576] Compiling C++ object scipy/_lib/_uarray/_uarray.cpython-310-x86_64-linux-gnu.so.p/vectorcall.cxx.o
  [12/1576] Compiling C object scipy/special/libcephes.a.p/cephes_airy.c.o
  [13/1576] Generating scipy/special/_ufuncs_pxi_pxd with a custom command
  ninja: build stopped: subcommand failed.
  + meson setup --native-file=/mnt/g/Maths/sage-9.8/b4.0/var/tmp/sage/build/scipy-1.9.2/src/.mesonpy-native-file.ini -Ddebug=false -Doptimization=2 --prefix=/mnt/g/Maths/sage-9.8/b4.0 /mnt/g/Maths/sage-9.8/b4.0/var/tmp/sage/build/scipy-1.9.2/src /mnt/g/Maths/sage-9.8/b4.0/var/tmp/sage/build/scipy-1.9.2/src/.mesonpy-dqhuq2qq/build
  + meson compile
  Traceback (most recent call last):
    File "/mnt/g/Maths/sage-9.8/b4.0/lib/python3.10/site-packages/pip/_vendor/pep517/in_process/_in_process.py", line 144, in prepare_metadata_for_build_wheel
      hook = backend.prepare_metadata_for_build_wheel
  AttributeError: module 'mesonpy' has no attribute 'prepare_metadata_for_build_wheel'

  During handling of the above exception, another exception occurred:

  Traceback (most recent call last):
    File "/mnt/g/Maths/sage-9.8/b4.0/lib/python3.10/site-packages/pip/_vendor/pep517/in_process/_in_process.py", line 351, in <module>
      main()
    File "/mnt/g/Maths/sage-9.8/b4.0/lib/python3.10/site-packages/pip/_vendor/pep517/in_process/_in_process.py", line 333, in main
      json_out['return_val'] = hook(**hook_input['kwargs'])
    File "/mnt/g/Maths/sage-9.8/b4.0/lib/python3.10/site-packages/pip/_vendor/pep517/in_process/_in_process.py", line 148, in prepare_metadata_for_build_wheel
      whl_basename = backend.build_wheel(metadata_directory, config_settings)
    File "/mnt/g/Maths/sage-9.8/b4.0/lib/python3.10/site-packages/mesonpy/__init__.py", line 987, in build_wheel
      return project.wheel(out).name
    File "/mnt/g/Maths/sage-9.8/b4.0/lib/python3.10/site-packages/mesonpy/__init__.py", line 935, in wheel
      wheel = self._wheel_builder.build(self._build_dir)
    File "/mnt/g/Maths/sage-9.8/b4.0/lib/python3.10/site-packages/mesonpy/__init__.py", line 576, in build
      self._project.build()  # ensure project is built
    File "/mnt/g/Maths/sage-9.8/b4.0/lib/python3.10/site-packages/mesonpy/__init__.py", line 765, in build
      self._meson('compile')
    File "/mnt/g/Maths/sage-9.8/b4.0/lib/python3.10/site-packages/mesonpy/__init__.py", line 696, in _meson
      return self._proc('meson', *args)
    File "/mnt/g/Maths/sage-9.8/b4.0/lib/python3.10/site-packages/mesonpy/__init__.py", line 691, in _proc
      subprocess.check_call(list(args))
    File "/mnt/g/Maths/sage-9.8/b4.0/lib/python3.10/subprocess.py", line 369, in check_call
      raise CalledProcessError(retcode, cmd)
  subprocess.CalledProcessError: Command '['meson', 'compile']' returned non-zero exit status 1.
  error: subprocess-exited-with-error
 
  × Preparing metadata (pyproject.toml) did not run successfully.
  ? exit code: 1
  ??> See above for output.
 
  note: This error originates from a subprocess, and is likely not a problem with pip.
  full command: /mnt/g/Maths/sage-9.8/b4.0/bin/python3 /mnt/g/Maths/sage-9.8/b4.0/lib/python3.10/site-packages/pip/_vendor/pep517/in_process/_in_process.py prepare_metadata_for_build_wheel /tmp/tmpjme9vjd8
  cwd: /mnt/g/Maths/sage-9.8/b4.0/var/tmp/sage/build/scipy-1.9.2/src
  Preparing metadata (pyproject.toml): finished with status 'error'
error: metadata-generation-failed

× Encountered error while generating package metadata.
??> See above for output.

note: This is an issue with the package mentioned above, not pip.
hint: See above for details.
**************************************************************************************************************************************************************************************************
Error building a wheel for scipy-1.9.2
**************************************************************************************************************************************************************************************************
...
...
</scipy-1.9.2.log>

Dima Pasechnik

unread,
Nov 27, 2022, 11:56:06 AM11/27/22
to sage-...@googlegroups.com
On Sun, Nov 27, 2022 at 8:10 AM being nobody00 <beingn...@gmail.com> wrote:
>
> > What OS?
> $ uname -a
> Linux PC1 4.4.0-17763-Microsoft #2268-Microsoft Thu Oct 07 16:36:00 PST 2021 x86_64 x86_64 x86_64 GNU/Linux
>

this is a guest OS of WSL, as far as I know, and very old one (4+
y.o., and unsupported since early 2022, as far as Linux kernels go).
Probably your WSL is old, too.

Problably /mnt/g is (from yur Linux point of view) a filesystem of
different to /home's type type,
and the hell breaks loose there (old WSL versions were known to
operate quite badly across
different filesystems, not sure if that improved)
> --
> You received this message because you are subscribed to the Google Groups "sage-devel" group.
> To unsubscribe from this group and stop receiving emails from it, send an email to sage-devel+...@googlegroups.com.
> To view this discussion on the web visit https://groups.google.com/d/msgid/sage-devel/f8c2f04c-a19b-4b5f-8efa-fa6e44b06fden%40googlegroups.com.

Matthias Koeppe

unread,
Nov 27, 2022, 4:46:26 PM11/27/22
to sage-devel
/usr/include/x86_64-linux-gnu/sys/cdefs.h:453:10: fatal error: scipy/_lib/_uarray/_uarray.cpython-310-x86_64-linux-gnu.so.p/bits/long-double.h: Invalid argument

These are sporadic system call errors that are known to happen on WSL. See https://trac.sagemath.org/ticket/31088

Just restarting the build will typically solve the problem.

being nobody00

unread,
Nov 27, 2022, 11:45:40 PM11/27/22
to sage-devel
Hi,

I am sorry that I could not get back to you sooner.
Thank you so much for the advice, I will try it out and report back.

Best regards,

phi

being nobody00

unread,
Nov 27, 2022, 11:53:48 PM11/27/22
to sage-devel
Hi,

I am sorry that I could not get back to you sooner.
Thanks for reminding me the problems of WSL and the vintage of my machine.

Best regards,

phi
Reply all
Reply to author
Forward
0 new messages